from panda3d.core import Vec2, Vec4

from direct.showbase.ShowBase import ShowBase
from terrain import Terrain
import random

class DataChunk():
    def __init__(self):
        self.color = None

class MyApp(ShowBase):

    def __init__(self):
        ShowBase.__init__(self)

        self.terrain_system = Terrain()
        self.terrain_system.spectator = base.camera

        base.taskMgr.add(self.update_terrain_system, "update_terrain_system")

        WORLD_MAP = 200
        for x in range((WORLD_MAP*2)+1):
            for y in range((WORLD_MAP*2)+1):

                data_chunk = DataChunk()
                data_chunk.color = Vec4(random.random(), random.random(), random.random(), 1)

                self.terrain_system.add_сhunk_storage(Vec2(x-WORLD_MAP, y-WORLD_MAP), data_chunk)

    def update_terrain_system(self, task):
        self.terrain_system.update()
        return task.cont

app = MyApp()
app.run()














'''from modules.template import FPS
from modules.cameras import FreeCamera
from modules.environment import Environment

# Создадим экземпляр камеры.
free_camera = FreeCamera()

# Установим контроль для камеры.
fps.control.set_object(free_camera)

environment = Environment(free_camera)

# Установим наблюдателя для ландшафта.
fps.terrain_system.spectator = free_camera.camera

#fps.world.set_render_mode_wireframe()
#skybox.write_bam_file("skybox.bam")


# Создание отладочной информации путем рендера в текстуру буфера кликабельных объектов.
if False:
    from panda3d.core import NodePath
    from panda3d.core import CardMaker
    cm = CardMaker("Debug").generate()
    card = NodePath(cm)
    card.set_scale(20)
    card.reparent_to(fps.world)
    card.set_texture(environment.buffer.get_texture())


while not fps.win.is_closed():

    clock = fps.clock
    
    # Обработка событий.
    fps.button_events()

    # Обновляем контролируемый объект.
    fps.control.update()

    # Обновляем террайн систему.
    fps.terrain_system.update()
    
    environment.update(clock)

    # Рендерим кадр.
    fps.engine.render_frame()'''